'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _path = require('path');

/**
 * @private
 * @type {String}
 */
var MODULE_PREFIX = 'webpack-config';

exports.default = [
/**
 * `require('<module-name>')`
 * @param {String} value
 * @returns {String|Error}
 */
function (value) {
    try {
        return require.resolve(value);
    } catch (err) {
        return err;
    }
},

/**
 * `require('webpack-config-<name>')`
 * @param {String} value
 * @returns {String|Error}
 */
function (value) {
    try {
        return require.resolve(MODULE_PREFIX + '-' + value);
    } catch (err) {
        return err;
    }
},

/**
 * `path.resolve('<file-name>')`
 * @param {String} value
 * @returns {String}
 */
function (value) {
    return (0, _path.resolve)(value);
}];
module.exports = exports['default'];
//# sourceMappingURL=ConfigPathDefaultResolvers.js.map